//
// Test app by George Harth <george@modeblue.com>
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MultipleHistorySample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private IESignal.HooksClass esignal;

		private string[] symbolsSmall =
		{
			
			/* "GE","AWE","PFE","TWX","MOT","EMC","C","TXN","HPQ","XOM","MU","F",
			"DIS","AMD","SBC","WMT","JPM","TYC","BMY","JNJ","HD","MRK","VZ","VIA.B","NEM",
			"SGP","BAC","WYE","GM","USB","MO","AA","T","KO","ET","AIG","AV","IBM","MCD",
			"CD","MDT","FON","ABT","AXP","XRX","GPS","BLS","MER","MWD","PEP","LUV","BSX",
			"FDC","NSM","KRB","HAL","TGT","CMX","WFC","DD","KSS","ONE","BBY","LOW","EDS",
			"KR","CFC","WM","DUK","SLB","LLY","RIG","FNM","WB","TER","JCP","GS","A","CC",
			"MAT","LMT","FCX","DOW","GDT","ADI","BK","CCU","LTD","PG","EK","BAX","WAG","HON",
			"X","PVN","ADM","SWY","BA","MMM","CA" */
			"ANL-LON", "ITV-LON", "PRU-LON", "RSA-LON", "SGE-LON", "VOD-LON",
			"ALTR", "DELL", "EBAY", "MSFT", "ORCL", "YHOO",
			"KR", "HPQ","MOT","BSX","TWX", "VZ"
		};
		private string[] symbolsBig = 
			{
				"GE","AWE","PFE","EMC","C","TXN","XOM","MU","F",
				"DIS","AMD","SBC","WMT","JPM","TYC","BMY","JNJ","HD","MRK","VIA.B","NEM",
				"SGP","BAC","WYE","GM","USB","MO","AA","T","KO","ET","AIG","AV","IBM","MCD",
				"CD","MDT","FON","ABT","AXP","XRX","GPS","BLS","MER","MWD","PEP","LUV",
				"FDC","NSM","KRB","HAL","TGT","CMX","WFC","DD","KSS","ONE","BBY","LOW","EDS",
				"CFC","WM","DUK","SLB","LLY","RIG","FNM","WB","TER","JCP","GS","A","CC",
				"MAT","LMT","FCX","DOW","GDT","ADI","BK","CCU","LTD","PG","EK","BAX","WAG","HON",
				"X","PVN","ADM","SWY","BA","MMM","CA",
				"ANL-LON", "ITV-LON", "PRU-LON", "RSA-LON", "SGE-LON", "VOD-LON",
				"ALTR", "DELL", "EBAY", "MSFT", "ORCL", "YHOO",
				"KR", "HPQ","MOT","BSX","TWX", "VZ"
			};
		private symbolInfo[] symbolInfoArray = null;
			
		private System.Windows.Forms.TextBox usernameTextBox;
		private System.Windows.Forms.Button startBtn;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.Label lastTimeLabel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtHistory;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private int miHistory = 0;
		//	The number of symbols for which data has been received
		private string msHistory = "";
		//	Contents of the history text box
		private int miHistory100Len;
		private int miQuote100Len;
		private int miTimeSales100Len;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage pagHistory;
		private System.Windows.Forms.TabPage pagRealTime;
		private System.Windows.Forms.Button cmdStartRealTime;
		private System.Windows.Forms.TextBox txtQuote;
		private System.Windows.Forms.TabPage pagTimeSales;
		private System.Windows.Forms.Button cmdStartTimeSales;
		private System.Windows.Forms.TextBox txtTimeSales;
		private System.Windows.Forms.CheckBox chkDisplayErrors;
		private System.Windows.Forms.TextBox txtErrors;
		private System.Windows.Forms.TabPage pagHistory2;
		private System.Windows.Forms.Button cmdHistory2;
		private System.Windows.Forms.TextBox txtHistory2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtHistoryInterval;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox cboHistoryType;
		private System.Windows.Forms.TextBox txtHistoryNumBars;
		private System.Windows.Forms.TextBox txtHistoryStartTime;
		private System.Windows.Forms.TextBox txtHistoryEndTime;
		private System.Windows.Forms.CheckBox chkSmallList;
		//	Length of the history text box when it contains 100 items

		private clsApp moApp;
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			esignal = new IESignal.HooksClass();
			esignal.OnBarsReceived += new IESignal._IHooksEvents_OnBarsReceivedEventHandler(esignal_OnBarsReceived);
			esignal.OnBarsChanged += new IESignal._IHooksEvents_OnBarsChangedEventHandler(esignal_OnBarsChanged);
			esignal.OnQuoteChanged += new IESignal._IHooksEvents_OnQuoteChangedEventHandler(esignal_OnQuoteChanged);
			esignal.OnTimeSalesChanged += new IESignal._IHooksEvents_OnTimeSalesChangedEventHandler(esignal_OnTimeSalesChanged);

			listView1.View = View.Details;
			listView1.Columns.Add("", 25, HorizontalAlignment.Left);
			listView1.Columns.Add("Symbol", 50, HorizontalAlignment.Left);
			listView1.Columns.Add("Open", 60, HorizontalAlignment.Right);
			listView1.Columns.Add("High", 60, HorizontalAlignment.Right);
			listView1.Columns.Add("Low", 60, HorizontalAlignment.Right);
			listView1.Columns.Add("Close", 60, HorizontalAlignment.Right);
			listView1.Columns.Add("Volume", 60, HorizontalAlignment.Right);
			listView1.Columns.Add("Time", 60, HorizontalAlignment.Center);

			miHistory100Len = (42 * 99) + 40;
			//	First line does not contain the CRLF
			miQuote100Len = (30 * 99) + 28;
			miTimeSales100Len = (26 * 99) + 24;

			moApp = new clsApp();
			moApp.InitPageWF();
			esignal.ReleaseAllHistory();
			esignal.ReleaseAllTimeSales();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			esignal.ReleaseAllHistory();
			esignal.ReleaseAllTimeSales();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void mInitGrid() 
		{
			int iLen;
			string sSymbol;

			if (this.chkSmallList.Checked) 
			{
				iLen = symbolsSmall.Length;
			} 
			else 
			{
				iLen = symbolsBig.Length;
			}
			symbolInfoArray = new symbolInfo[iLen];
			for (int idx = 0; idx < iLen; ++idx) 
			{
				symbolInfoArray[idx] = new symbolInfo();
				if (this.chkSmallList.Checked) 
				{
					sSymbol = symbolsSmall[idx];
					
				} 
				else 
				{
					sSymbol = symbolsBig[idx];
				}
				symbolInfoArray[idx].symbol = sSymbol;
				ListViewItem item = new ListViewItem((idx + 1).ToString());
				item.SubItems.Add(sSymbol);
				item.SubItems.Add("");
				item.SubItems.Add("");
				item.SubItems.Add("");
				item.SubItems.Add("");
				item.SubItems.Add("");
				item.SubItems.Add("");
				listView1.Items.Add(item);
				symbolInfoArray[idx].item = item;	// Store it for faster access later
			}
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.startBtn = new System.Windows.Forms.Button();
			this.listView1 = new System.Windows.Forms.ListView();
			this.usernameTextBox = new System.Windows.Forms.TextBox();
			this.lastTimeLabel = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.txtHistory = new System.Windows.Forms.TextBox();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.pagHistory = new System.Windows.Forms.TabPage();
			this.pagRealTime = new System.Windows.Forms.TabPage();
			this.cmdStartRealTime = new System.Windows.Forms.Button();
			this.txtQuote = new System.Windows.Forms.TextBox();
			this.pagTimeSales = new System.Windows.Forms.TabPage();
			this.cmdStartTimeSales = new System.Windows.Forms.Button();
			this.txtTimeSales = new System.Windows.Forms.TextBox();
			this.pagHistory2 = new System.Windows.Forms.TabPage();
			this.cmdHistory2 = new System.Windows.Forms.Button();
			this.txtHistory2 = new System.Windows.Forms.TextBox();
			this.chkDisplayErrors = new System.Windows.Forms.CheckBox();
			this.txtErrors = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtHistoryInterval = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.cboHistoryType = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtHistoryNumBars = new System.Windows.Forms.TextBox();
			this.txtHistoryStartTime = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.txtHistoryEndTime = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.chkSmallList = new System.Windows.Forms.CheckBox();
			this.tabControl1.SuspendLayout();
			this.pagHistory.SuspendLayout();
			this.pagRealTime.SuspendLayout();
			this.pagTimeSales.SuspendLayout();
			this.pagHistory2.SuspendLayout();
			this.SuspendLayout();
			// 
			// startBtn
			// 
			this.startBtn.Location = new System.Drawing.Point(392, 8);
			this.startBtn.Name = "startBtn";
			this.startBtn.Size = new System.Drawing.Size(64, 24);
			this.startBtn.TabIndex = 1;
			this.startBtn.Text = "Start";
			this.startBtn.Click += new System.EventHandler(this.startBtn_Click);
			// 
			// listView1
			// 
			this.listView1.CausesValidation = false;
			this.listView1.FullRowSelect = true;
			this.listView1.GridLines = true;
			this.listView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listView1.Location = new System.Drawing.Point(8, 40);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(488, 200);
			this.listView1.TabIndex = 2;
			// 
			// usernameTextBox
			// 
			this.usernameTextBox.Location = new System.Drawing.Point(64, 8);
			this.usernameTextBox.Name = "usernameTextBox";
			this.usernameTextBox.Size = new System.Drawing.Size(80, 20);
			this.usernameTextBox.TabIndex = 0;
			this.usernameTextBox.Text = "geoff_olding";
			// 
			// lastTimeLabel
			// 
			this.lastTimeLabel.Location = new System.Drawing.Point(8, 8);
			this.lastTimeLabel.Name = "lastTimeLabel";
			this.lastTimeLabel.Size = new System.Drawing.Size(192, 18);
			this.lastTimeLabel.TabIndex = 3;
			this.lastTimeLabel.Text = "Last Time =";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(10, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "usrname";
			// 
			// txtHistory
			// 
			this.txtHistory.Location = new System.Drawing.Point(8, 248);
			this.txtHistory.Multiline = true;
			this.txtHistory.Name = "txtHistory";
			this.txtHistory.Size = new System.Drawing.Size(488, 144);
			this.txtHistory.TabIndex = 6;
			this.txtHistory.Text = "";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.pagHistory);
			this.tabControl1.Controls.Add(this.pagRealTime);
			this.tabControl1.Controls.Add(this.pagTimeSales);
			this.tabControl1.Controls.Add(this.pagHistory2);
			this.tabControl1.Location = new System.Drawing.Point(4, 120);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(512, 404);
			this.tabControl1.TabIndex = 7;
			// 
			// pagHistory
			// 
			this.pagHistory.Controls.Add(this.txtHistory);
			this.pagHistory.Controls.Add(this.lastTimeLabel);
			this.pagHistory.Controls.Add(this.startBtn);
			this.pagHistory.Controls.Add(this.listView1);
			this.pagHistory.Location = new System.Drawing.Point(4, 22);
			this.pagHistory.Name = "pagHistory";
			this.pagHistory.Size = new System.Drawing.Size(504, 378);
			this.pagHistory.TabIndex = 0;
			this.pagHistory.Text = "History";
			// 
			// pagRealTime
			// 
			this.pagRealTime.Controls.Add(this.cmdStartRealTime);
			this.pagRealTime.Controls.Add(this.txtQuote);
			this.pagRealTime.Location = new System.Drawing.Point(4, 22);
			this.pagRealTime.Name = "pagRealTime";
			this.pagRealTime.Size = new System.Drawing.Size(504, 378);
			this.pagRealTime.TabIndex = 1;
			this.pagRealTime.Text = "Real Time";
			// 
			// cmdStartRealTime
			// 
			this.cmdStartRealTime.Location = new System.Drawing.Point(8, 8);
			this.cmdStartRealTime.Name = "cmdStartRealTime";
			this.cmdStartRealTime.Size = new System.Drawing.Size(64, 24);
			this.cmdStartRealTime.TabIndex = 8;
			this.cmdStartRealTime.Text = "Start";
			this.cmdStartRealTime.Click += new System.EventHandler(this.cmdStartRealTime_Click);
			// 
			// txtQuote
			// 
			this.txtQuote.Location = new System.Drawing.Point(6, 38);
			this.txtQuote.Multiline = true;
			this.txtQuote.Name = "txtQuote";
			this.txtQuote.Size = new System.Drawing.Size(490, 350);
			this.txtQuote.TabIndex = 8;
			this.txtQuote.Text = "";
			// 
			// pagTimeSales
			// 
			this.pagTimeSales.Controls.Add(this.cmdStartTimeSales);
			this.pagTimeSales.Controls.Add(this.txtTimeSales);
			this.pagTimeSales.Location = new System.Drawing.Point(4, 22);
			this.pagTimeSales.Name = "pagTimeSales";
			this.pagTimeSales.Size = new System.Drawing.Size(504, 378);
			this.pagTimeSales.TabIndex = 2;
			this.pagTimeSales.Text = "Time and Sales";
			// 
			// cmdStartTimeSales
			// 
			this.cmdStartTimeSales.Location = new System.Drawing.Point(8, 8);
			this.cmdStartTimeSales.Name = "cmdStartTimeSales";
			this.cmdStartTimeSales.Size = new System.Drawing.Size(64, 24);
			this.cmdStartTimeSales.TabIndex = 9;
			this.cmdStartTimeSales.Text = "Start";
			this.cmdStartTimeSales.Click += new System.EventHandler(this.cmdStartTimeSales_Click);
			// 
			// txtTimeSales
			// 
			this.txtTimeSales.Location = new System.Drawing.Point(8, 40);
			this.txtTimeSales.Multiline = true;
			this.txtTimeSales.Name = "txtTimeSales";
			this.txtTimeSales.Size = new System.Drawing.Size(490, 344);
			this.txtTimeSales.TabIndex = 9;
			this.txtTimeSales.Text = "";
			// 
			// pagHistory2
			// 
			this.pagHistory2.Controls.Add(this.cmdHistory2);
			this.pagHistory2.Controls.Add(this.txtHistory2);
			this.pagHistory2.Location = new System.Drawing.Point(4, 22);
			this.pagHistory2.Name = "pagHistory2";
			this.pagHistory2.Size = new System.Drawing.Size(504, 378);
			this.pagHistory2.TabIndex = 3;
			this.pagHistory2.Text = "History 2";
			// 
			// cmdHistory2
			// 
			this.cmdHistory2.Location = new System.Drawing.Point(8, 8);
			this.cmdHistory2.Name = "cmdHistory2";
			this.cmdHistory2.Size = new System.Drawing.Size(64, 24);
			this.cmdHistory2.TabIndex = 10;
			this.cmdHistory2.Text = "Start";
			this.cmdHistory2.Click += new System.EventHandler(this.cmdHistory2_Click);
			// 
			// txtHistory2
			// 
			this.txtHistory2.Location = new System.Drawing.Point(8, 40);
			this.txtHistory2.Multiline = true;
			this.txtHistory2.Name = "txtHistory2";
			this.txtHistory2.Size = new System.Drawing.Size(488, 352);
			this.txtHistory2.TabIndex = 10;
			this.txtHistory2.Text = "";
			// 
			// chkDisplayErrors
			// 
			this.chkDisplayErrors.Location = new System.Drawing.Point(158, 10);
			this.chkDisplayErrors.Name = "chkDisplayErrors";
			this.chkDisplayErrors.Size = new System.Drawing.Size(104, 18);
			this.chkDisplayErrors.TabIndex = 8;
			this.chkDisplayErrors.Text = "Display Errors";
			// 
			// txtErrors
			// 
			this.txtErrors.Location = new System.Drawing.Point(12, 32);
			this.txtErrors.Name = "txtErrors";
			this.txtErrors.Size = new System.Drawing.Size(504, 20);
			this.txtErrors.TabIndex = 9;
			this.txtErrors.Text = "(No Errors)";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(150, 60);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 23);
			this.label2.TabIndex = 9;
			this.label2.Text = "Interval";
			// 
			// txtHistoryInterval
			// 
			this.txtHistoryInterval.Location = new System.Drawing.Point(202, 64);
			this.txtHistoryInterval.Name = "txtHistoryInterval";
			this.txtHistoryInterval.TabIndex = 10;
			this.txtHistoryInterval.Text = "1";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(308, 62);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 23);
			this.label3.TabIndex = 11;
			this.label3.Text = "Type";
			// 
			// cboHistoryType
			// 
			this.cboHistoryType.Items.AddRange(new object[] {
																"Bars",
																"Days"});
			this.cboHistoryType.Location = new System.Drawing.Point(364, 66);
			this.cboHistoryType.Name = "cboHistoryType";
			this.cboHistoryType.Size = new System.Drawing.Size(121, 21);
			this.cboHistoryType.TabIndex = 12;
			this.cboHistoryType.Text = "Bars";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(10, 92);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(60, 23);
			this.label4.TabIndex = 13;
			this.label4.Text = "Bars\\Days";
			// 
			// txtHistoryNumBars
			// 
			this.txtHistoryNumBars.Location = new System.Drawing.Point(74, 94);
			this.txtHistoryNumBars.Name = "txtHistoryNumBars";
			this.txtHistoryNumBars.Size = new System.Drawing.Size(76, 20);
			this.txtHistoryNumBars.TabIndex = 14;
			this.txtHistoryNumBars.Text = "1";
			// 
			// txtHistoryStartTime
			// 
			this.txtHistoryStartTime.Location = new System.Drawing.Point(220, 96);
			this.txtHistoryStartTime.Name = "txtHistoryStartTime";
			this.txtHistoryStartTime.Size = new System.Drawing.Size(76, 20);
			this.txtHistoryStartTime.TabIndex = 16;
			this.txtHistoryStartTime.Text = "0";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(156, 94);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(60, 23);
			this.label5.TabIndex = 15;
			this.label5.Text = "Start Time";
			// 
			// txtHistoryEndTime
			// 
			this.txtHistoryEndTime.Location = new System.Drawing.Point(370, 98);
			this.txtHistoryEndTime.Name = "txtHistoryEndTime";
			this.txtHistoryEndTime.Size = new System.Drawing.Size(76, 20);
			this.txtHistoryEndTime.TabIndex = 18;
			this.txtHistoryEndTime.Text = "0";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(306, 96);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(60, 23);
			this.label6.TabIndex = 17;
			this.label6.Text = "End Time";
			// 
			// chkSmallList
			// 
			this.chkSmallList.Location = new System.Drawing.Point(10, 58);
			this.chkSmallList.Name = "chkSmallList";
			this.chkSmallList.TabIndex = 19;
			this.chkSmallList.Text = "Cut Down List";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(522, 534);
			this.Controls.Add(this.chkSmallList);
			this.Controls.Add(this.txtHistoryEndTime);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.txtHistoryStartTime);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.txtHistoryNumBars);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.cboHistoryType);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.txtErrors);
			this.Controls.Add(this.chkDisplayErrors);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.usernameTextBox);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.txtHistoryInterval);
			this.Name = "Form1";
			this.Text = "Multiple Stock Streams Test";
			this.tabControl1.ResumeLayout(false);
			this.pagHistory.ResumeLayout(false);
			this.pagRealTime.ResumeLayout(false);
			this.pagTimeSales.ResumeLayout(false);
			this.pagHistory2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void startBtn_Click(object sender, System.EventArgs e)
		{
			mHistoryStart(1);
		}

		private int historyHandleToIndex(int lHandle)
		{
			for (int idx = 0; idx < symbolInfoArray.Length; ++idx)
			{
				if (lHandle == symbolInfoArray[idx].historyHandle)
				{
					return idx;
				}
			}
			return -1;
		}

		private int timesalesHandleToIndex(int vlHandle)
		{
			for (int idx = 0; idx < symbolInfoArray.Length; ++idx)
			{
				if (vlHandle == symbolInfoArray[idx].timesalesHandle)
				{
					return idx;
				}
			}
			return -1;
		}

		private void esignal_OnBarsReceived(int lHandle)
		{
			mHistory(lHandle);
		}

		private void esignal_OnBarsChanged(int lHandle)
		{
			mHistory(lHandle);
		}

		private void mHistory(int vlHandle) 
		{
			
			mProcessBar(vlHandle);
			mProcessBarLog(vlHandle);
		}

		private bool mbInProcessBarLog = false;
		private void mProcessBarLog(int vlHandle) 
		{

			try 
			{
				System.Data.SqlClient.SqlCommand scmdLog = null;
				string sSP;

				if (mbInProcessBarLog == true) 
				{
					return;
				}
				mbInProcessBarLog = true;
				int index = historyHandleToIndex(vlHandle);
				if ((index >= 0) && (esignal.get_GetNumBars(vlHandle) > 0))
				{
					IESignal.BarData bd = esignal.get_GetBar(vlHandle, 0);
					if (miHistoryVer == 1) 
					{
						sSP = "spiESignalDownloadHistory"; 
						} 
					else 
					{
						sSP = "spiESignalDownloadHistory2";
					}
					if (!CLib.clsCLib.clslDB_bCommandOpenSP_Par(sSP, ref scmdLog,
						"@sESignalStockName", symbolInfoArray[index].symbol)) 
					{
						mPause();
						goto mProcessBarLog_done;
					}
					scmdLog.Parameters.Add("@dClose", bd.dClose);
					scmdLog.Parameters.Add("@dtTime", bd.dtTime);

					if (miHistoryVer == 1) 
					{
						scmdLog.Parameters.Add("@dOpen",bd.dOpen);
						scmdLog.Parameters.Add("@dHigh", bd.dHigh);
						scmdLog.Parameters.Add("@dLow", bd.dLow);
						scmdLog.Parameters.Add("@dVolume", bd.dVolume);
						scmdLog.Parameters.Add("@btbfFlags", bd.bfFlags);
						scmdLog.Parameters.Add("@dOI", bd.dOI);
						scmdLog.Parameters.Add("@dTickBid", bd.dTickBid);
						scmdLog.Parameters.Add("@dTickAsk", bd.dTickAsk);
						scmdLog.Parameters.Add("@dTickTrade", bd.dTickTrade);
					}
					if (!GLibWeb.clslDB.bExecuteNonQueryAffectedCheck(scmdLog, false,false, 
						GLibWeb.clslApp.eSecurityLevel.iWrite)) 
					{
						mPause();
						goto mProcessBarLog_done;
					}
				}
				mbInProcessBarLog = false;
			} 
			catch (Exception exMain) 
			{
				mHandleException(exMain);
			}
			mProcessBarLog_done:
				mbInProcessBarLog = false;
		}

		private void mPause() 
		{
			//	Pauses the application
		}

		private void mProcessBar(int vlHandle)
			//	Processes a stock price
		{
			int index = historyHandleToIndex(vlHandle);
			string sHistory;
			if ((index >= 0) && (esignal.get_GetNumBars(vlHandle) > 0))
			{
				IESignal.BarData bd = esignal.get_GetBar(vlHandle, 0);
				if (miHistoryVer == 1) 
				{
					ListViewItem item = symbolInfoArray[index].item;
					item.SubItems[2].Text = bd.dOpen.ToString();
					item.SubItems[3].Text = bd.dHigh.ToString();
					item.SubItems[4].Text = bd.dLow.ToString();
					item.SubItems[5].Text = bd.dClose.ToString();
					item.SubItems[6].Text = bd.dVolume.ToString();
					item.SubItems[7].Text = bd.dtTime.ToShortTimeString();
					lastTimeLabel.Text = "Last Time = " + bd.dtTime.ToShortTimeString() + 
						" [" + symbolInfoArray[index].symbol + "]";
				}

				//	Number
				sHistory = (miHistory + 1).ToString().PadRight(4, ' ');
				//	Symbol
				sHistory+= symbolInfoArray[index].symbol.PadRight(6,' ');
				//	Time
				sHistory+= bd.dtTime.ToShortTimeString().PadRight(10, ' ');
				//	High
				sHistory+= bd.dHigh.ToString().PadRight(10, ' ');
				//	Low
				sHistory+= bd.dLow.ToString().PadRight(10, ' ');

				if (miHistory != 0) 
				{
					msHistory = "\r\n" + msHistory;
				}
				miHistory+=1;
				msHistory= sHistory + msHistory;

				if (miHistory >= 100) 
				{
					//	Truncate to the first 100 lines
					msHistory = msHistory.Substring(0, miHistory100Len);
					
				} 
				if (miHistoryVer == 1) 
				{
					this.txtHistory.Text = msHistory;
				} 
				else 
				{
					this.txtHistory2.Text = msHistory;
				}
			} 
		}

		private void cmdStartRealTime_Click(object sender, System.EventArgs e)
		{
			esignal.SetApplication(usernameTextBox.Text);

			if (esignal.IsEntitled == 0)
			{
				MessageBox.Show("Not entitled");
			}
			else 
			{
				// esignal.ReleaseAllHistory();
				// esignal.ReleaseAllTimeSales();
				foreach (symbolInfo info in symbolInfoArray)
				{
					// We are going to display the OHLC of 1 minute bars, so ask for them
					esignal.RequestSymbol(info.symbol, -1);
				}
				this.cmdStartRealTime.Enabled = false;
				usernameTextBox.Enabled = false;
			}
		}

		private bool mbInProcessQuote = false;
		private bool mbInProcessQuoteLog = false;
		private int miQuote = 0;
		private string msQuote = "";
		
		private void esignal_OnQuoteChanged(string vsData)
		{
			mProcessQuote(vsData);
			mProcessQuoteLog(vsData);
		}

		private void mProcessQuote(string vsSymbol) 
		{
			IESignal.BasicQuote quote;
			string sQuote;
			try 
			{
				if (mbInProcessQuote == true) 
				{
					return;
				}
				mbInProcessQuote = true;
				quote = esignal.get_GetBasicQuote(vsSymbol);

				sQuote = miQuote.ToString().PadRight(6, ' ');
				sQuote+= vsSymbol.PadRight(4, ' ');
				sQuote+= quote.dAsk.ToString().PadRight(6, ' ');
				sQuote+= quote.dBid.ToString().PadRight(6, ' ');
				sQuote+= quote.dLast.ToString().PadRight(6, ' ');

				if (miQuote != 0) 
				{
					msQuote = "\r\n" + msQuote;
				}
				msQuote = sQuote + msQuote;
				miQuote+=1;
				if (miQuote >= 100) 
				{
					//	Truncate to the first 100 lines
					msQuote = msQuote.Substring(0, miQuote100Len);
				} 
				this.txtQuote.Text = msQuote;

			}
			catch (Exception exMain) 
			{
				mHandleException(exMain);
			}
			mbInProcessQuote = false;
		}

		private void mProcessQuoteLog(string vsSymbol) 
		{
			IESignal.BasicQuote quote;
			try 
			{
				System.Data.SqlClient.SqlCommand scmdLog = null;

				if (mbInProcessQuoteLog == true) 
				{
					return;
				}
				mbInProcessQuoteLog = true;
				
				if (!CLib.clsCLib.clslDB_bCommandOpenSP_Par("spiESignalDownloadQuote", ref scmdLog,
					"@sESignalStockName", vsSymbol)) 
				{
					mPause();
					goto mProcessQuoteLog_done;
				}

				quote = esignal.get_GetBasicQuote(vsSymbol);

				scmdLog.Parameters.Add("@dAsk", quote.dAsk);
				scmdLog.Parameters.Add("@dBid", quote.dBid);
				scmdLog.Parameters.Add("@dLast", quote.dLast);
				scmdLog.Parameters.Add("@ilAskSize", quote.lAskSize);
				scmdLog.Parameters.Add("@ilBidSize", quote.lBidSize);
				scmdLog.Parameters.Add("@ilLastSize", quote.lLastSize);
			
				if (!GLibWeb.clslDB.bExecuteNonQueryAffectedCheck(scmdLog, false,false, 
					GLibWeb.clslApp.eSecurityLevel.iWrite)) 
				{
					mPause();
					goto mProcessQuoteLog_done;
				}
			}
			catch (Exception exMain) 
			{
				mHandleException(exMain);
			}
			mProcessQuoteLog_done:
				mbInProcessQuoteLog = false;
		}

		private void cmdStartTimeSales_Click(object sender, System.EventArgs e)
		{
			esignal.SetApplication(usernameTextBox.Text);
			IESignal.TimeSalesFilter filter;

			if (esignal.IsEntitled == 0)
			{
				MessageBox.Show("Not entitled");
			}
			else 
			{
				foreach (symbolInfo info in symbolInfoArray)
				{

					filter = new IESignal.TimeSalesFilter();
					filter.bFilterPrice = 0;
					filter.bFilterQuoteExchanges = 0;
					filter.bFilterTradeExchanges = 0;
					filter.bFilterVolume = 0;
					filter.bQuotes = 1;
					filter.bTrades = 1;
					filter.lNumDays = 1;
					filter.sSymbol = info.symbol;
					info.timesalesHandle = esignal.get_RequestTimeSales(ref filter);

					if (esignal.get_IsTimeSalesReady(info.timesalesHandle) != 0) 
					{
						// Data already in cache, won't receive event until next "live" tick
						// StatusLabel.Text = "History Complete"
					}
					else 
					{
						//StatusLabel.Text = "Request Sent"
					}
				}
				this.cmdStartTimeSales.Enabled = false;
				usernameTextBox.Enabled = false;
			}
		}

		private void esignal_OnTimeSalesChanged(int vlHandle) 
		{
			mProcessTimeSales(vlHandle);
			mProcessTimeSalesLog(vlHandle);
		}

		private bool mbInProcessSalesTime = false;
		private bool mbInProcessSalesTimeLog = false;
		private int miTimeSales = 0;
		private string msTimeSales ="";
		private void mProcessTimeSales(int vlHandle) 
		{
			IESignal.TimeSalesData tick;
			int index = timesalesHandleToIndex(vlHandle);
			// int index = historyHandleToIndex(vlHandle);
			string sTick;

			try 
			{
				if (mbInProcessSalesTime == true) 
				{
					return;
				}
				mbInProcessSalesTime = true;
				if (esignal.get_IsTimeSalesReady(vlHandle) != 0) 
				{
					// Data already in cache, won't receive event until next "live" tick
					// StatusLabel.Text = "History Complete"
				}
				else 
				{
					//StatusLabel.Text = "Request Sent"
				}
				tick = esignal.get_GetTimeSalesBar(vlHandle, 0);
				if (index >= 0) 
				{
					sTick = miTimeSales.ToString().PadRight(6, ' ');
					sTick+= symbolInfoArray[index].symbol.PadRight(6, ' ');
					sTick+= tick.dPrice.ToString().PadRight(6, ' ');
					sTick+= tick.dtTime.ToShortTimeString().PadRight(6, ' ');
				
					if (miTimeSales != 0) 
					{
						msTimeSales = "\r\n" + msTimeSales;
					}
					msTimeSales = sTick + msTimeSales;
					miTimeSales+=1;
					if (miTimeSales >= 100) 
					{
						//	Truncate to the first 100 lines
						msTimeSales = msTimeSales.Substring(0, miTimeSales100Len);
					} 
					this.txtTimeSales.Text = msTimeSales;
				}
			}
			catch (Exception exMain) 
			{
				mHandleException(exMain);
			}
			mbInProcessSalesTime = false;
		}

		private void mProcessTimeSalesLog(int vlHandle)
		{
			System.Data.SqlClient.SqlCommand scmdLog = null;
			IESignal.TimeSalesData tick;
			int index = timesalesHandleToIndex(vlHandle);

			if (mbInProcessSalesTimeLog == true) 
			{
				return;
			}
			mbInProcessSalesTimeLog = true;
			if (esignal.get_IsTimeSalesReady(vlHandle) != 0) 
			{
				// Data already in cache, won't receive event until next "live" tick
				// StatusLabel.Text = "History Complete"
			}
			else 
			{
				//StatusLabel.Text = "Request Sent"
			}
			if (index >= 0) 
			{
				tick = esignal.get_GetTimeSalesBar(vlHandle, 0);
				if (!CLib.clsCLib.clslDB_bCommandOpenSP_Par("spiESignalDownloadTimeSales", ref scmdLog,
					"@sESignalStockName", symbolInfoArray[index].symbol)) 
				{
					mPause();
					goto mProcessTimeSalesLog_done;
				}
				scmdLog.Parameters.Add("@dPrice", tick.dPrice);
				scmdLog.Parameters.Add("@dtTime", tick.dtTime);
				scmdLog.Parameters.Add("@lFlags", tick.lFlags);
				scmdLog.Parameters.Add("@lSize",tick.lSize);
				GLibWeb.clslDB.AddParStringNull(scmdLog, "@sExchange", tick.sExchange);
				if (!GLibWeb.clslDB.bExecuteNonQueryAffectedCheck(scmdLog, false,false, 
					GLibWeb.clslApp.eSecurityLevel.iWrite)) 
				{
					mPause();
					goto mProcessTimeSalesLog_done;
				}
			}
mProcessTimeSalesLog_done:
		mbInProcessSalesTimeLog = false;
		}

		private int miErrors = 0;
		private void mHandleException(Exception vexError)
		{
			//	Standard error handling for this form
			moApp.pbHideErrors = (!this.chkDisplayErrors.Checked);
			moApp.bHandleException_NoContext(vexError);
			if (!this.chkDisplayErrors.Checked) 
			{
				miErrors += 1;
				this.txtErrors.Text = miErrors.ToString() + " " + vexError.Message;
			}
		}

		private void cmdHistory2_Click(object sender, System.EventArgs e)
		{
			mHistoryStart(2);		
		}

		private int miHistoryVer =0;
		private void mHistoryStart(int viHistoryVer)
		{
			IESignal.barType eBarType;
			int iNumBars, iStartTime, iEndTime;

			miHistoryVer = viHistoryVer;
			esignal.SetApplication(usernameTextBox.Text);

			if (esignal.IsEntitled == 0)
			{
				MessageBox.Show("Not entitled");
			}
			else 
			{
				// esignal.ReleaseAllHistory();
				// esignal.ReleaseAllTimeSales();
				mInitGrid();
				foreach (symbolInfo info in symbolInfoArray)
				{
					// We are going to display the OHLC of 1 minute bars, so ask for them
					/* info.historyHandle = esignal.get_RequestHistory(info.symbol,sInterval, 
						IESignal.barType.btDAYS,1, -1, -1); */
					if (this.cboHistoryType.Text == "Bars") 
					{
						eBarType = IESignal.barType.btBARS;
					} 
					else 
					{
						eBarType = IESignal.barType.btDAYS;
					}
					iNumBars = CLib.clsVB.iCint(this.txtHistoryNumBars.Text);
					iStartTime = CLib.clsVB.iCint(this.txtHistoryStartTime.Text);
					iEndTime = CLib.clsVB.iCint(this.txtHistoryEndTime.Text);
					info.historyHandle = esignal.get_RequestHistory(info.symbol,this.txtHistoryInterval.Text, 
						 eBarType , iNumBars, iStartTime , iEndTime);
				}
				if (miHistoryVer == 1) 
				{
					startBtn.Enabled = false; 
				} 
				else 
				{
					this.cmdHistory2.Enabled = false;
				}
				usernameTextBox.Enabled = false;
			}
		}
	}

	public class symbolInfo
	{
		public int historyHandle = -1;
		public int timesalesHandle = -1;
		public string symbol = "";
		public ListViewItem item = null;
	}
}
